#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "m": 10,
    "mx": 10**9,
    "size": 1,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():

    def comp_size(i, j):
        if (i, j) in visited:
            return 0
        visited.add((i, j))
        res = 1
        for (dx, dy) in [(0,1), (0,-1), (1,0), (-1,0)]:
            if (i+dx, j+dy) in chosen:
                res += comp_size(i+dx, j+dy)
        return res

    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    m = int(cmdlinearg("m"))
    mx = int(cmdlinearg("mx"))
    size = int(cmdlinearg("size"))

    visited = set()
    chosen = set()
    cells = []
    for i in range(0, n):
        for j in range(0, m):
            cells.append((i, j))
    random.shuffle(cells)

    for (i, j) in cells:
        if len(chosen) >= mx:
            break
        visited = set()
        if comp_size(i, j) <= size:
            chosen.add((i, j))
    
    print(n,m)
    for i in range(0, n):
        line = []
        for j in range(0, m):
            if (i, j) in chosen:
                line.append('2')
            else:
                line.append('1')
        print("".join(line))


if __name__ == "__main__":
    main()